import 'dart:convert';
import 'dart:typed_data';
import 'dart:ui';

class NfcNdefMessage {
  NfcNdefMessage(this.records);

  final List<NfcNdefRecord> records;
}

class NfcNdefRecord {
  NfcNdefRecord(this.id, this.payload, this.type, this.typeNameFormat);

  final Uint8List id;

  final Uint8List payload;

  final Uint8List type;

  final int typeNameFormat;

  factory NfcNdefRecord.createTextRecord(String text, {String languageCode}) {
    assert(text != null);
    final languageCodeBytes = ascii.encode(
      languageCode?.isNotEmpty == true ? languageCode : Locale.cachedLocale.languageCode,
    );
    assert(languageCodeBytes.length < 64);
    return NfcNdefRecord(
      null,
      Uint8List.fromList([languageCodeBytes.length] + languageCodeBytes + utf8.encode(text)),
      Uint8List.fromList([0x54]),
      0x01,
    );
  }
}
